#!/usr/local/bin/perl
# change upper line to your Perl PATH ie. "#!/usr/apps/perl"

# ---------------------------------------------------------------------------
#    Copyright(C) 1997,1998   IIZUKA,Shinji (siizuka@apollo.releenet.co.jp)
#    All rights reserved.
# ---------------------------------------------------------------------------
#
#    timeimg.cgi - image changer (by time/random)
#
#    This cgi DO NOT has any parameter.
#
#    history
#    1997.10.28  Newly Created
#    1998.01.21  Convert into Perl
#
# ---------------------------------------------------------------------------

$ident = "@(#) timeimg.cgi 1.1";
# $DEBUG_MODE = 1;

# ---------------------------------------------------------------------------
# U S E R   C U S T O M I Z E   A R E A
# list of image : set MIME type and path of images.
# ---------------------------------------------------------------------------
#
#   format is : 
#         file_name ; time from; time to
#         (ie. "../image/0.gif ; 12:00 ; 13:00")
#
#   notice:
#     * Only gif or jpeg type are supported.
#     * MIME types are asumed using suffix of images as:
#       suffix is     ".gif"  ->   MIME type is "image/gif"
#       suffix is NOT ".gif"  ->   MIME type is "image/jpeg"
#     * File name cannot contains ";" or spaces.
#     * Index of @img[] must start from ZERO.
# ---------------  CHANGE HERE -----------------
$default_img = "b_hiru.gif";           # default:change as you like

$img[0]  = "../image/b_asa.jpg  ; 7:00; 12:59";           # change as you like
$img[1]  = "../image/b_hiru.jpg ;13:00; 18:59";           # change as you like
$img[2]  = "../image/b_yoru.jpg ;19:00;  6:59";           # change as you like
# you can increase or decrease size of @img.

# ---------------------------------------------------------------------------
# E N D   O F   U S E R   C U S T O M I Z E   A R E A
# ---------------------------------------------------------------------------

# ------ DEFINITION OF FUNCTION ------------------------------
sub f_print_image {
	local ($image) = $_[0];

	local (@ary) = split ( /\./, $image );

	SWITCH: { 
		if ( $ary[$#ary] eq "gif"  ) { print "Content-type: image/gif\n\n" ; last SWITCH; }
		if ( $ary[$#ary] eq "png"  ) { print "Content-type: image/png\n\n" ; last SWITCH; }
		if ( $ary[$#ary] eq "jpg"  ) { print "Content-type: image/jpeg\n\n"; last SWITCH; }
	}

	open ( IN, "<$image" );
	print <IN>;
	close ( IN );
}

sub ensure_date {
	my( $in ) = $_[0];

	my( @ary ) = split ( /:/, $in );

	$ary[0] += 0; $ary[1] += 0;

	return sprintf ( "%02d:%02d", $ary[0], $ary[1] );
}


sub debug_print { 	# debug routine(you need not to delete this)
	return unless ( $DEBUG_MODE );

	my(@param) = @_;

	unless ( $DEBUG_OPENED ) {
		open( DBG, ">timeimg.log" );
		$DEBUG_OPENED = 1;
	}
	if ( $#param <= 0 ) {
		print DBG $param[0] . "\n";
	} else {
		print DBG join( '|',@param ) . "\n";
	}
}

# ------ DECIDE WHETHER MODE TO PROCESS ----------------------

if ($ENV{'REQUEST_METHOD'} eq 'POST') {
	read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
} elsif ( $ENV{'REQUEST_METHOD'} eq 'GET') {
 	$buffer = $ENV{'QUERY_STRING'};
} else {
	$buffer = "";
}

if ( $buffer eq "random" || $buffer eq "RANDOM" ) {
	$mode = "RANDOM";
} else {
	$mode = "TIME";
}

# ------ RANDOM MODE -----------------------------------------
if ( $mode eq "RANDOM" ) {
	srand();
	$r = int(rand($#img + 1));
	if ( $r <= $#img ) {
		@l = split(/;/,$img[$r]);
		$this_img = $l[0];
		$this_img =~ s/ //g;
	} else {
		$this_img = $default_img;
	}
	&f_print_image( $this_img );

# ------ TIME MODE -------------------------------------------
} else {
    # get system time
	($d1,$m,$h,$d2,$d3,$d4,$d5,$d6,$d7) = localtime(time);
	$n = sprintf ( "%02d:%02d",$h,$m );
	debug_print( 'a',$n );

	$max_ix = $#img;
	for ( $ix = 0; $ix <= $max_ix; $ix++ ) {
		@l = split(/;/,$img[$ix]);
		$l[0] =~ s/ //g; $l[1] =~ s/ //g; $l[2] =~ s/ //g; 
		$from = &ensure_date( $l[1] );
		$to   = &ensure_date( $l[2] );
		debug_print( 'b',@l );

		# from <= now <= to
		if ( ($from le $n) && ($n le $to) )  {
			&f_print_image( $l[0] );
			last;
		} else {
			if (($to le $n) && ($n le $from) && ($to lt $from)){
				&f_print_image( $l[0] );
				last;
			}
		}
	}
	if ( $r > $#img ) {
	} else {
		&f_print_image( $default_img );
	}
}
